/*****************************************************************************/
/*                             WiNRADiO G66WSB                               */
/*                                SDK DEMO                                   */
/*                        (c) Copyright RADIXON 2025                         */
/*****************************************************************************/

#ifndef __U_DEFS_H__
#define __U_DEFS_H__

#include "g66wsbapi.h"
#include <wx/wx.h>

#define APP_TITLE "G66WSB SDK Demo"

#define SONOBUOY_CHANNEL_MIN    1
#define SONOBUOY_CHANNEL_MAX    99
#define SONOBUOY_CHANNEL_COUNT  (SONOBUOY_CHANNEL_MAX-SONOBUOY_CHANNEL_MIN+1)

#define CONTROL_HEIGHT          24

//ms
#define UPDATE_INTERVAL         50

#define RBW_COUNT               6

#define MIN_FFT_SIZE            1024
#define MAX_FFT_SIZE            32768

#define AUDIO_SAMPLE_RATE       64000

#define FFT_SIZE_DDC            2048
#define FFT_SIZE_AUDIO          2048

#define DDC_COUNT_LIMIT         2

#define ALING_SAMPLE_COUNT(Count)   ((Count+63)&(~63))

#if ALING_SAMPLE_COUNT(G66WSB_DDC_SAMPLE_RATE*UPDATE_INTERVAL/1000)<FFT_SIZE_DDC
#error DDC FFT is too large!
#endif


#endif
